require 'sinatra'
require 'sinatra/reloader' if development?
require_relative 'lib/fraction_list'
require_relative 'lib/fraction'

also_reload 'lib/fraction_list'

configure do
  set :fractions, FractionList.init_from_file
end

get '/' do
  @fractions = settings.fractions
  erb :index
end

get '/fractions/new' do
  erb :new_fraction
end

post '/fractions/new' do
  fraction = Fraction.new(params["nominator"].to_i, params["denominator"].to_i)
  settings.fractions.add(fraction)
  redirect to('/')
end

get '/summs' do
  @summs = settings.fractions.summs
  erb :summs
end

get '/fractions/edit/:index' do
  @fraction = settings.fractions.by_index(params["index"].to_i)
  erb :edit_fraction
end

