# frozen_string_literal: true

require_relative 'fraction'

class FractionList

  def self.init_from_file
    fractions = FractionList.new
    fractions.read_from_file(File.expand_path('../data/input-1.txt', __dir__))
    fractions
  end

  def initialize
    @fractions = []
  end

  def read_from_file(file_name)
    strings = File.readlines(file_name)
    new_fractions = strings.map do |string|
      parts = string.split('/').map(&:strip).map(&:to_i)
      Fraction.new(*parts)
    end
    @fractions.concat(new_fractions)
  end

  def summs
    results = []
    @fractions.each_with_index do |first, index|
      @fractions.slice(index + 1, @fractions.size).each do |second|
        results.append({
          first: first,
          second: second,
          summ: first.sum(second)
        })
      end
    end
    results
  end

  def each
    return enum_for(:each) unless block_given?
    @fractions.each do |fraction|
      yield fraction
    end
  end

  def add(fraction)
    @fractions.append(fraction)
  end

  def by_index(index)
    @fractions[index]
  end
end
